using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using ILOG.Diagrammer;
using ILOG.Diagrammer.Graphic;
using ILOG.Diagrammer.Windows.Forms;

using SimulationEngine;

namespace CustomSymbols
{
    public partial class DiagramCanvas:UserControl
    {
        private Diagram1 jigsawDiagram = null;

        private SimulationController _simuController = null;

        public DiagramCanvas()
        {
            InitializeComponent();

            jigsawDiagram = new Diagram1();
            this.diagramView1.Content = jigsawDiagram;
        }

        public void SetSimuController(SimulationController simuController)
        {
            if(simuController == null) throw new ArgumentNullException("DiagramCanvas(SimulationController simuController)");

            _simuController = simuController;

            this.JIGSAWDiagram.Init(_simuController);
        }

        public Diagram1 JIGSAWDiagram
        {
            get
            {
                return jigsawDiagram;
            }
        }

        public void ShowAll()
        {
            this.diagramView1.ShowAll();
            this.diagramView1.Zoom(new Point(diagramView1.Width / 2, diagramView1.Height / 2), 0.925f, 0.925f);
            //this.diagramView1.Refresh();
        }
    }
}
