using System;
using ILOG.Diagrammer;
using ILOG.Diagrammer.Graphic;
using System.Drawing;
using ILOG.Diagrammer.Filters;
using System.Drawing.Drawing2D;

using SimulationEngine;

namespace CustomSymbols
{
    partial class UserInterface
    {
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region ILOG Diagrammer Designer generated code
        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.basic2DShape1 = new ILOG.Diagrammer.Graphic.Basic2DShape();
            this.UIRectHeader = new ILOG.Diagrammer.Graphic.Path();
            this.UserInterfaceSymbol = new ILOG.Diagrammer.Graphic.GraphicSymbol();
            ((System.ComponentModel.ISupportInitialize)(this.UserInterfaceSymbol)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this)).BeginInit();
            // 
            // basic2DShape1
            // 
            this.basic2DShape1.ControlValue = 0.5F;
            this.basic2DShape1.Fill = new ILOG.Diagrammer.SolidFill(System.Drawing.Color.WhiteSmoke);
            this.basic2DShape1.Name = "basic2DShape1";
            this.basic2DShape1.Rectangle = new ILOG.Diagrammer.Rectangle2D(68.9166F, 11.8125F, 216.8F, 100F);
            this.basic2DShape1.Transform = new ILOG.Diagrammer.Transform(1F, 0F, 0F, 1F, 239.5834F, 244.1875F);
            // 
            // UIRectHeader
            // 
            this.UIRectHeader.Data.SetGeometry(@"M534.75 265.1299C534.7501 265.1299 534.7502 265.1299 534.7503 265.1299L534.75 265.1299L534.75 265.1299zM704.7451 264.9987C704.6612 264.9987 704.5774 264.9992 704.4937 265L534.75 265L534.75 265.1299L534.75 265.1299C534.6668 265.1291 534.5834 265.1287 534.5 265.1287C520.8329 265.1287 509.7537 276.2079 509.7537 289.875C509.7537 290.0002 509.7546 290.1252 509.7564 290.25L729.4864 290.25C729.4897 290.0821 729.4915 289.9138 729.4915 289.7451C729.4915 276.078 718.4121 264.9987 704.7451 264.9987z");
            this.UIRectHeader.Data.Transform = new ILOG.Diagrammer.Transform(0.9863201F, 0F, 0F, 1.023763F, -491.757F, -249.4409F);
            this.UIRectHeader.Fill = new ILOG.Diagrammer.SolidFill(System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(191)))), ((int)(((byte)(207))))));
            this.UIRectHeader.Name = "UIRectHeader";
            this.UIRectHeader.Transform = new ILOG.Diagrammer.Transform(1F, 0F, 0F, 1F, 297.5834F, 234.1875F);
            // 
            // UserInterfaceSymbol
            // 
            this.UserInterfaceSymbol.Name = "UserInterfaceSymbol";
            this.UserInterfaceSymbol.Objects.Add(this.basic2DShape1);
            this.UserInterfaceSymbol.Objects.Add(this.UIRectHeader);
            this.UserInterfaceSymbol.MouseClick += new ILOG.Diagrammer.ObjectMouseEventHandler(this.UserInterfaceSymbol_MouseClick);
            this.UserInterfaceSymbol.MouseEnter += new ILOG.Diagrammer.ObjectEventHandler(this.UserInterfaceSymbol_MouseEnter);
            this.UserInterfaceSymbol.MouseLeave += new ILOG.Diagrammer.ObjectEventHandler(this.UserInterfaceSymbol_MouseLeave);
            // 
            // UserInterface
            // 
            this.DefaultSize = new ILOG.Diagrammer.Size2D(216.875F, 100F);
            this.Objects.Add(this.UserInterfaceSymbol);
            ((System.ComponentModel.ISupportInitialize)(this.UserInterfaceSymbol)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this)).EndInit();

        }

        #endregion

        private SimulationController _simuController = null;
        public void SetSimuController(SimulationController simuController)
        {
            _simuController = simuController;
        }

        void UserInterfaceSymbol_MouseClick(object sender, ObjectMouseEventArgs e)
        {
            if(_simuController.Started) return;

            // Toggle Highlight
            /*
            if (this.isSelected.Equals(false))
            {
                this.Highlight();
                
                this.isSelected = true;
            }
            else
            {
                this.Unhighlight();
                
                this.isSelected = false;
            }
            */

            _simuController.SelectScreen(this.Name);
            _simuController.SetCurrentScreen(this.Name);
        }

        void UserInterfaceSymbol_MouseEnter(object sender, ObjectEventArgs e)
        {
            /*
            if(!_simuController.Started)
                this._simuController.SwapScreenIn(this.Name);
             */
        }

        void UserInterfaceSymbol_MouseLeave(object sender, ObjectEventArgs e)
        {
            /*
            if(!_simuController.Started)
                this._simuController.SwapScreenOut();
             */
        }

        public void FillSymbol()
        {   
            //this.basic2DShape1.Fill = new SolidFill(System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(191)))), ((int)(((byte)(207))))));
            this.UIRectHeader.Fill = new SolidFill(System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(171)))), ((int)(((byte)(207))))));
        }

        public void UnFillSymbol()
        {
            //this.basic2DShape1.Fill = new SolidFill(Color.White);
            this.UIRectHeader.Fill = new SolidFill(System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(191)))), ((int)(((byte)(207))))));
        }

        public void Highlight()
        {
            //TODO: Show glow for this symbol
            Stroke stroke = new Stroke();
            stroke.DashStyle = DashStyle.Dash;
            stroke.Fill = new SolidFill(Color.Red);
            stroke.Width = 3;
            this.basic2DShape1.Stroke = stroke;
        }

        public void Unhighlight()
        {
            //TODO: Remove glow from this symbol
            Stroke stroke = new Stroke();
            stroke.Fill = new SolidFill(System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(191)))), ((int)(((byte)(207))))));
            stroke.Width = 3;
            this.basic2DShape1.Stroke = stroke;
        }
        private bool isSelected;
        private Basic2DShape basic2DShape1;
        private Path UIRectHeader;
        private GraphicSymbol UserInterfaceSymbol;
    }
}
