﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

using SimulationEngine;

namespace JIGSAWApplication
{
	public partial class MyNewToolbarTrayControl
	{
        private SimulationEngine.SimulationController _simuController;

		public MyNewToolbarTrayControl()
		{
			this.InitializeComponent();

			// Insert code required on object creation below this point.
            this.btStartTesting.Click += new RoutedEventHandler(btStartTesting_Click);
            this.btServiceA.Click += new RoutedEventHandler(btServiceA_Click);
            this.btEdit.Click += new RoutedEventHandler(btEdit_Click);

            this.btVerify.Click += new RoutedEventHandler(btVerify_Click);
            this.btShare.Click += new RoutedEventHandler(btShare_Click);
		}

        private void btShare_Click(object sender, RoutedEventArgs e)
        {
            //TODO: How to indicate sharing at this point? Dialog?
        }

        private void btVerify_Click(object sender, RoutedEventArgs e)
        {
            //TODO: Show errors in the workflow view
        }

        private void btEdit_Click(object sender, RoutedEventArgs e)
        {
            //TODO: Show "Not yet implemented"
            MessageBox.Show("Not yet implemented", "Info", MessageBoxButton.OK, MessageBoxImage.Information);
        }

        private void btServiceA_Click(object sender, RoutedEventArgs e)
        {
            if(_simuController != null)
            {
                _simuController.ShowStartDialog();
            }
        }

        private void btStartTesting_Click(object sender, RoutedEventArgs e)
        {
            if(_simuController != null)
            {
                _simuController.Start();
            }
        }

        public void SetSimuController(SimulationController simuController)
        {
            _simuController = simuController;
            _simuController.SimulationStateChanged += new SimulationController.SimulationStateChangedHandler(_simuController_SimulationStateChanged);
        }

        private void _simuController_SimulationStateChanged(object sender, bool started)
        {
            if(started)
            {
                this.btStartTesting.Content = "Stop Testing";
                this.btStartTesting.ToolTip = "Stop Testing";
            }
            else
            {
                this.btStartTesting.Content = "Start Testing";
                this.btStartTesting.ToolTip = "Start Testing";
            }
        }
	}
}