﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Collections;
using System.Windows.Controls.Primitives;

namespace JIGSAWApplication
{
	public partial class ProcessView_MyNewToolbarTrayControl
	{
        private ToggleButton[] _toolbarButtons = null;

        public ProcessView_MyNewToolbarTrayControl()
		{
			this.InitializeComponent();

            _toolbarButtons = new ToggleButton[]{this.btAddConnection, this.btAddDecision, this.btAddEndState, this.btAddStartState, this.btAddSystemTask, this.btAddTask};

            this.btAddConnection.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddDecision.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddEndState.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddStartState.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddSystemTask.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddTask.Checked += new RoutedEventHandler(ToggleButton_Checked);
        }

        void ToggleButton_Checked(object sender, RoutedEventArgs e)
        {
            ToggleButton thisButton = (ToggleButton)sender;

            foreach(ToggleButton tb in _toolbarButtons)
            {
                if(tb != thisButton)
                {
                    tb.IsChecked = false;
                }
            }
        }

        public void ResetToggleButtons()
        {
            foreach(ToggleButton tb in _toolbarButtons)
            {
                tb.IsChecked = false;
            }
        }
	}
}