﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

using SimulationEngine;

namespace JIGSAWApplication
{
	public partial class ScopeSelectionPanel
	{
        private SimulationController _simuController = null;
       
		public ScopeSelectionPanel()
		{
			this.InitializeComponent();
        }

        public void SetSimuController(SimulationController simuController)
        {
            if(simuController == null) throw new ArgumentNullException("SetSimuController(SimulationController simuController)");
            _simuController = simuController;
            _simuController.SimulationStateChanged += new SimulationController.SimulationStateChangedHandler(_simuController_SimulationStateChanged);
        }

        void _simuController_SimulationStateChanged(object sender, bool started)
        {
            if(started)
            {
                this.IsEnabled = false;
            }
            else
            {
                this.IsEnabled = true;
            }
        }

        private void btClearSelection_Click(object sender, RoutedEventArgs e)
        {
            if(_simuController != null)
            {
                _simuController.ClearSelection();
            }
        }

        private void rbtSingleScreen_Checked(object sender, RoutedEventArgs e)
        {
            /*
            if(_simuController != null)
            {
                _simuController.SetSelectionScope(SelectionScope.SingleSelect);
            }
            */
        }

        private void rbtPathOfScreens_Checked(object sender, RoutedEventArgs e)
        {
            /*
            if(_simuController != null)
            {
                _simuController.SetSelectionScope(SelectionScope.MultiSelect);
            }
             * */
        }

        private void rbtAllScreens_Checked(object sender, RoutedEventArgs e)
        {
            /*
            if(_simuController != null)
            {
                _simuController.SetSelectionScope(SelectionScope.All);
            }
             * */
        }

        
	}
}