﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Threading;
using System.Windows.Threading;
using JIGSAWApplication;

namespace JIGSAWApplication
{
    public delegate void CloseSplashDelegate();

	public partial class SplashWindow
	{
        private Thread splashThread;

        private ThreadStart splashWorkDelegate = null;

		public SplashWindow()
		{
			this.InitializeComponent();
			
			// Insert code required on object creation below this point.
            splashWorkDelegate = new ThreadStart(SplashWork);
            splashThread = new Thread(splashWorkDelegate);
            splashThread.Start();
		}

        public void SplashWork()
        {
            System.Threading.Thread.Sleep(500);
            this.Dispatcher.BeginInvoke(DispatcherPriority.Normal, new CloseSplashDelegate(CloseSplashScreen));
        }

        private void CloseSplashScreen()
        {
            this.Close();
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            Window1 win = new Window1();
            App.Current.MainWindow = win;
            win.Show();
            base.OnClosing(e);
        }
	}
}