﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Controls.Primitives;

namespace JIGSAWApplication
{
	public partial class TaskView_MyNewToolbarTrayControl
	{
        private ToggleButton[] _toolbarButtons = null;

        public TaskView_MyNewToolbarTrayControl()
		{
			this.InitializeComponent();

            _toolbarButtons = new ToggleButton[] { this.btAddDataConnection, this.btAddNavConnection};

            this.btAddDataConnection.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddInterface.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddNavConnection.Checked += new RoutedEventHandler(ToggleButton_Checked);
            this.btAddService.Checked += new RoutedEventHandler(ToggleButton_Checked);
		}

        void ToggleButton_Checked(object sender, RoutedEventArgs e)
        {
            ToggleButton thisButton = (ToggleButton)sender;

            foreach(ToggleButton tb in _toolbarButtons)
            {
                if(tb != thisButton)
                {
                    tb.IsChecked = false;
                }
            }

            if(thisButton == this.btAddInterface)
                this.btAddService.IsChecked = false;
            else if(thisButton == this.btAddService)
                this.btAddInterface.IsChecked = false;
        }

        public void ResetToggleButtons()
        {
            foreach(ToggleButton tb in _toolbarButtons)
            {
                tb.IsChecked = false;
            }
        }

        public void ResetLibraryToggleButtons()
        {
            this.btAddInterface.IsChecked = false;
            this.btAddService.IsChecked = false;
        }
	}
}