﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace JIGSAWApplication
{
	public partial class navigationPanel
	{
        public event SwitchViewHandler ViewSwitchedEvent;
        public event EventHandler ToggleDataDependency;

		public navigationPanel()
        {
            this.InitializeComponent();

            AttachObservers();
        }

        private void AttachObservers()
        {
            //this.processView.Click +=new RoutedEventHandler(processView_Click);
            //this.testingView.Click +=new RoutedEventHandler(testingView_Click);
            //this.workflowView.Click += new RoutedEventHandler(workflowView_Click);

            this.navigator.OriginalSliderPos = ViewSlider.SliderPos.TestPos;

            this.navigator.SliderChangedEvent += new ViewSlider.UserControl1.SliderChangedHandler(navigator_SliderChangedEvent);
        }

        void navigator_SliderChangedEvent(object sender, ViewSlider.SliderPos sliderPos)
        {
            switch(sliderPos)
            {
                case ViewSlider.SliderPos.ProcessPos:
                    OnViewSwitched(JIGSAWMode.ProcessView);
                    break;

                case ViewSlider.SliderPos.WorkflowPos:
                    OnViewSwitched(JIGSAWMode.WorkflowComposer);
                    break;

                case ViewSlider.SliderPos.TestPos:
                    OnViewSwitched(JIGSAWMode.Testing);
                    break;

                default:
                    break;
            }
        }

        private void workflowView_Click(object sender, RoutedEventArgs e)
        {
            OnViewSwitched(JIGSAWMode.WorkflowComposer);
        }

        private void testingView_Click(object sender, RoutedEventArgs e)
        {
            OnViewSwitched(JIGSAWMode.Testing);
        }

        private void processView_Click(object sender, RoutedEventArgs e)
        {
            OnViewSwitched(JIGSAWMode.ProcessView);
        }

        public MyNewToolbarTrayControl ToolBar
        {
            get
            {
                return this.simuToolbar;
            }
        }

        private void OnViewSwitched(JIGSAWMode mode)
        {
            if(ViewSwitchedEvent != null)
            {
                ViewSwitchedEvent(this, mode);
            }
        }
	}
}