using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ProcessScreenRepository
{
    /// <summary>
    /// Interaction logic for ProcessScreen1.xaml
    /// </summary>

    public partial class ProcessScreen1:System.Windows.Controls.UserControl, ISimulatable
    {
        public delegate void LoginSubmittedEventHandler(ProcessScreen1 screen, LoginEventArgs e);
        public event LoginSubmittedEventHandler LoginSubmittedEvent;
        private void OnLoginSubmitted()
        {
            if(LoginSubmittedEvent != null)
            {
                LoginSubmittedEvent(this, new LoginEventArgs(this.txtUserId.Text, this.txtPassword.Password));
            }
        }


        public ProcessScreen1()
        {
            InitializeComponent();
            this.btOKService1.Click += new RoutedEventHandler(btOKService1_Click);
        }

        void btOKService1_Click(object sender, RoutedEventArgs e)
        {
            OnLoginSubmitted();
        }


        #region ISimulatable Members

        public System.Collections.ArrayList GetButtons()
        {
            System.Collections.ArrayList buttons = new System.Collections.ArrayList();

            buttons.Add(this.btOKService1);

            return buttons;
        }

        #endregion
    }

    public class LoginEventArgs:EventArgs
    {
        private string _name;
        private string _password;

        public LoginEventArgs(string name, string password)
        {
            this._name = name;
            this._password = password;
        }

        public string Name
        {
            get
            {
                return _name;
            }
        }

        public string Password
        {
            get
            {
                return _password;
            }
        }
    }
}