﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace WorkflowLibraryTemplates
{
	public partial class InterfaceLibraryTemplate
	{
        private LibraryController _libController = null;

        public event EventHandler AddScreenEvent;

        private string _currentLabel = "New UI Screen";
        public string CurrentLabel
        {
            get
            {
                return _currentLabel;
            }
        }

        private UserControl[] _previews = {
                new preview1(),
                new preview2(),
                new preview3(),
                new preview4(),
                new preview5(),
                new preview6(),
                new preview7(),
                new preview8(),
                new preview9(),
                new preview10()
            };

        public InterfaceLibraryTemplate()
		{
			this.InitializeComponent();

            _libController = new LibraryController(this, this._previews, this.detailsBorder, this.gridUIs);

            this.gridUIs.Children.Clear();

			// Insert code required on object creation below this point.
            
            this.screen1.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen1.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen2.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen2.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen3.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen3.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen4.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen4.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen5.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen5.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen6.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen6.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen7.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen7.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen8.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen8.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen9.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen9.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen10.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen10.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddScreen_PreviewMouseDown);
            this.screen10.Click += new RoutedEventHandler(screen10_Click);
		}

        void AddScreen_PreviewMouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            OnAddScreenEvent();
        }

        void screen10_Click(object sender, RoutedEventArgs e)
        {
            _currentLabel = "Email Sent Confirmation";
        }
               

        private void InterfaceLibraryCatalog_Click(object sender, RoutedEventArgs e)
        {
            string categoryName = ((Button)sender).Name;

            _libController.HideAll();

            switch(categoryName.ToLower())
            {
                case "btlogin":
                    _libController.Show(this.screen1);
                    _libController.ThumbToggleButton_Click(this.screen1, null);
                    return;
                case "btcustomerview":
                    _libController.Show(this.screen2);
                    _libController.ThumbToggleButton_Click(this.screen2, null);
                    return;
                case "btcustomerlist":
                    _libController.Show(this.screen3);
                    _libController.ThumbToggleButton_Click(this.screen3, null);
                    return;
                case "btcomplaintsdetail":
                    _libController.Show(this.screen4);
                    _libController.Show(this.screen5);
                    _libController.ThumbToggleButton_Click(this.screen4, null);
                    return;
                case "btcomplaintslist":
                    _libController.Show(this.screen6);
                    _libController.ThumbToggleButton_Click(this.screen6, null);
                    return;
                case "btexpertslist":
                    _libController.Show(this.screen7);
                    _libController.ThumbToggleButton_Click(this.screen7, null);
                    return;
                case "btorderlist":
                    _libController.Show(this.screen8);
                    _libController.ThumbToggleButton_Click(this.screen8, null);
                    return;
                case "btreviewdetail":
                    _libController.Show(this.screen9);
                    _libController.Show(this.screen10);
                    _libController.ThumbToggleButton_Click(this.screen9, null);
                    return;
                default:
                    break;
            }

            _libController.CheckCurrent();  
        }

        public Button BtAddUIScreen
        {
            get
            {
                return this.btAddUIScreen;
            }
        }

        private void OnAddScreenEvent()
        {
            if(AddScreenEvent != null)
            {
                AddScreenEvent(null, EventArgs.Empty);
            }
        }
	}
}