﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace WorkflowLibraryTemplates
{
	public partial class ServiceLibraryTemplate
	{
        private LibraryController _libController = null;

        public event EventHandler AddServiceEvent;

        private string _currentLabel = "New Service";
        public string CurrentLabel
        {
            get
            {
                return _currentLabel;
            }
        }


        private UserControl[] _previews = {
                new detail1(),
                new detail2(),
                new detail3(),
                new detail4(),
                new detail5(),
                new detail6(),
                new detail7(),
                new detail8(),
                new detail9(),
                new detail10()
            };

		public ServiceLibraryTemplate()
		{
			this.InitializeComponent();

            _libController = new LibraryController(this, this._previews, this.detailsBorder, this.gridUIs);

            this.gridUIs.Children.Clear();

			// Insert code required on object creation below this point.
            this.screen1.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen1.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen2.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen2.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen3.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen3.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen4.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen4.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen5.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen5.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen6.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen6.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen7.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen7.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen8.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen8.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen9.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen9.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen10.Click += new RoutedEventHandler(_libController.ThumbToggleButton_Click);
            this.screen10.PreviewMouseDown += new System.Windows.Input.MouseButtonEventHandler(AddService_PreviewMouseDown);
            this.screen10.Click += new RoutedEventHandler(screen10_Click);
		}

        void AddService_PreviewMouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            OnAddServiceEvent();
        }

        void screen10_Click(object sender, RoutedEventArgs e)
        {
            _currentLabel = "Email Notification Service";
        }

        private void ServiceLibraryCatalog_Click(object sender, RoutedEventArgs e)
        {
            string categoryName = ((Button)sender).Name;

            _libController.HideAll();

            switch(categoryName.ToLower())
            {
                case "btcomplaints":
                    _libController.Show(this.screen1);
                    _libController.ThumbToggleButton_Click(this.screen1, null);
                    return;
                case "btcustomer":
                    _libController.Show(this.screen2);
                    _libController.ThumbToggleButton_Click(this.screen2, null);
                    return;
                case "btemployee":
                    _libController.Show(this.screen3);
                    _libController.ThumbToggleButton_Click(this.screen3, null);
                    return;
                case "btexcel":
                    _libController.Show(this.screen4);
                    _libController.Show(this.screen5);
                    _libController.ThumbToggleButton_Click(this.screen4, null);
                    return;
                case "btgeneral":
                    _libController.Show(this.screen6);
                    _libController.ThumbToggleButton_Click(this.screen6, null);
                    return;
                case "btorder":
                    _libController.Show(this.screen7);
                    _libController.ThumbToggleButton_Click(this.screen7, null);
                    return;
                case "btsales":
                    _libController.Show(this.screen8);
                    _libController.ThumbToggleButton_Click(this.screen8, null);
                    return;
                case "btworkflow":
                    _libController.Show(this.screen9);
                    _libController.Show(this.screen10);
                    _libController.ThumbToggleButton_Click(this.screen9, null);
                    return;
                default:
                    break;
            }

            _libController.CheckCurrent();
        }

        public Button BtAddService
        {
            get
            {
                return this.btAddService;
            }
        }

        private void OnAddServiceEvent()
        {
            if(AddServiceEvent != null)
            {
                AddServiceEvent(null, EventArgs.Empty);
            }
        }
	}
}